VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "NPort TCP Server Example"
   ClientHeight    =   2580
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4785
   LinkTopic       =   "Form1"
   ScaleHeight     =   2580
   ScaleWidth      =   4785
   StartUpPosition =   3  'Windows Default
   Begin VB.Timer Timer1 
      Left            =   120
      Top             =   2040
   End
   Begin VB.CommandButton cmdStop 
      Caption         =   "Stop Server"
      Height          =   375
      Left            =   3360
      TabIndex        =   2
      Top             =   2040
      Width           =   1095
   End
   Begin VB.TextBox txtPort 
      BeginProperty DataFormat 
         Type            =   1
         Format          =   "0"
         HaveTrueFalseNull=   0
         FirstDayOfWeek  =   0
         FirstWeekOfYear =   0
         LCID            =   1028
         SubFormatType   =   1
      EndProperty
      Height          =   375
      Left            =   2160
      MaxLength       =   4
      TabIndex        =   0
      Text            =   "4000"
      Top             =   1560
      Width           =   855
   End
   Begin VB.CommandButton cmdStart 
      Caption         =   "Start Server"
      Height          =   375
      Left            =   3360
      TabIndex        =   1
      Top             =   1560
      Width           =   1095
   End
   Begin VB.Label Label3 
      Caption         =   "NPort TCP Server will start after selecting a port number and press the button ""Start Server""."
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   735
      Left            =   120
      TabIndex        =   4
      Top             =   360
      Width           =   4335
   End
   Begin VB.Label Label1 
      Caption         =   "TCP Server Port number"
      Height          =   255
      Left            =   120
      TabIndex        =   3
      Top             =   1680
      Width           =   1815
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'
' Project: TCP Server Example using VB
'
' Description:
'    This application contains a TCP server. The server creates
'    a TCP listening socket and waits for client connections.

'    When a connection is established, TCP server will read data from
'    the connection and echo it back to the TCP client.

'    Note that the server uses blocking sockets to accept connections
'    as well as send and receive data. This means once the server is
'    listening, and the UI will not refresh and the stop button will
'    not be pressed.

Option Explicit

Dim soc As Long
Dim LocalAddr As sockaddr
Dim RemoteAddr As sockaddr
Dim RetMsg As String
Dim ServerOn As Boolean
Dim AcceptSoc As Long
Dim hEvent As Long
Dim dwRc As Long
Dim Selidx As Integer
' start example program and initial display
Private Sub Form_Load()
    Timer1.Enabled = False
    Timer1.Interval = 10
    If TCPIPStartup Then
        cmdStart.Enabled = True
        cmdStop.Enabled = False
        txtPort.Enabled = True
        Timer1.Enabled = False
        Timer1.Interval = 10
        ServerOn = False
    Else
        MsgBox "Windows Sockets not initialized. Error: " & Err.LastDllError
    End If
    soc = INVALID_SOCKET
    hEvent = WSACreateEvent
End Sub

Private Sub Form_Unload(Cancel As Integer)
    TCPIPShutDown
    If hEvent <> 0 Then WSACloseEvent hEvent
End Sub
' press start button will start TCP server
Private Sub cmdStart_Click()
Dim AddrLen As Long
Dim ret As Long
Dim i, j As Integer
Dim te As Byte

    If txtPort.Text = "" Then
        MsgBox " Please enter host port number. "
        Exit Sub
    End If

    ' create socket for TCP Server
    soc = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP)
    If soc = INVALID_SOCKET Then
        MsgBox "Couldn't Create Socket. Error: " & Err.LastDllError
        Exit Sub
    Else
        LocalAddr.sin_family = AF_INET
        LocalAddr.sin_port = htons(CLng(txtPort.Text))
        LocalAddr.sin_addr = 0
    End If
        
    AddrLen = Len(LocalAddr)
    ' bind a socket for server
    ret = bind(soc, LocalAddr, AddrLen)
    If ret = SOCKET_ERROR Then
        MsgBox "Couldn't bind to Socket. Error: " & Err.LastDllError
        closesocket (soc)
        Exit Sub
    Else
        cmdStart.Enabled = False
        cmdStop.Enabled = True
        txtPort.Enabled = False
    End If
    'set listen number
    If listen(soc, 1) = SOCKET_ERROR Then
        MsgBox "Couldn't listen() to socket. Error: " & Err.LastDllError
        closesocket (soc)
        Exit Sub
    End If
    'wait client connection and accept connection
    AcceptSoc = accept(soc, RemoteAddr, sockaddr_size)
    If AcceptSoc = INVALID_SOCKET Then
        MsgBox "Couldn't accept a socket connection. Error: " & Err.LastDllError
        closesocket (soc)
        Exit Sub
    End If
    
    Timer1.Enabled = True

End Sub
' press stop button will stop TCP server and close socket
Private Sub cmdStop_Click()
    closesocket (AcceptSoc)
    closesocket (soc)
    cmdStart.Enabled = True
    cmdStop.Enabled = False
    txtPort.Enabled = True
    Timer1.Enabled = False
End Sub
' each time interval will let program enter timer routine.
Private Sub Timer1_Timer()
Dim strRecv As String
Dim retRecv, retSend As Long
    
    If soc = INVALID_SOCKET Then
        Debug.Print "Create Socket First"
        Exit Sub
    End If
    
    strRecv = String(1024, 0)
    ' set read socket event
    dwRc = WSAEventSelect(AcceptSoc, hEvent, FD_READ)
    If (dwRc = SOCKET_ERROR) Then
        MsgBox "Failed to select event. Error: " & Err.LastDllError
        Exit Sub
    End If
    
    ' wait for reading event
    dwRc = WSAWaitForMultipleEvents(1, hEvent, False, 0, False)
       
    Select Case dwRc
    Case WSA_WAIT_TIMEOUT
        Debug.Print "Recv timed out"
        
    Case WSA_WAIT_EVENT_0
        Dim NetworkEvents As WSANETWORKEVENTS
        Dim dwRet As Long
        NetworkEvents.lNetWorkEvents = 0
        dwRet = WSAEnumNetworkEvents(AcceptSoc, hEvent, NetworkEvents)
        If (dwRet = SOCKET_ERROR) Then
            MsgBox "WSAEnumNetworkEvents failed to select event. Error: " & Err.LastDllError
        Else
        'recv data from socket
            If (FD_READ And NetworkEvents.lNetWorkEvents) Then
                retRecv = recv(AcceptSoc, ByVal strRecv, Len(strRecv), 0)
                If retRecv = SOCKET_ERROR Then
                    MsgBox "Couldn't recieve data from remote Socket. Error: " & Err.LastDllError
                    closesocket (AcceptSoc)
                    closesocket (soc)
                    cmdStart.Enabled = True
                    cmdStop.Enabled = False
                    txtPort.Enabled = True
                    Timer1.Enabled = False
                    Exit Sub
                Else
        'send data to socket
                    retSend = send(AcceptSoc, ByVal strRecv, retRecv, 0)
                    If retSend = SOCKET_ERROR Then
                        MsgBox "Couldn't send data to remote Socket. Error: " & Err.LastDllError
                        closesocket (AcceptSoc)
                        closesocket (soc)
                        cmdStart.Enabled = True
                        cmdStop.Enabled = False
                        txtPort.Enabled = True
                        Timer1.Enabled = False
                        Exit Sub
                    ElseIf retSend = 0 Then
                        MsgBox "The connection has been interrupted. Error: " & Err.LastDllError
                        closesocket (AcceptSoc)
                        closesocket (soc)
                        cmdStart.Enabled = True
                        cmdStop.Enabled = False
                        txtPort.Enabled = True
                        Timer1.Enabled = False
                        Exit Sub
                    End If
                End If
            End If
        End If
    
    Case WSA_WAIT_FAILED
        MsgBox "WSAWaitForMultipleEvents failed. Error: " & Err.LastDllError
    Case Else
        MsgBox "Unexpected WSAWaitForMultipleEvents return. Error: " & Err.LastDllError
    End Select
    
    dwRc = WSAEventSelect(soc, hEvent, 0)
    If (dwRc = SOCKET_ERROR) Then
        MsgBox "Failed to select event. Error: " & Err.LastDllError
        Exit Sub
    End If
End Sub

Private Sub txtPort_Change()
Dim port As Byte

    If txtPort.SelStart = 0 Then
        Exit Sub
    Else
        Selidx = txtPort.SelStart
    End If
    If Len(txtPort.Text) > 0 Then
            port = Asc(Mid(txtPort.Text, txtPort.SelStart, 1))
            If port < Asc(0) Or port > Asc(9) Then
                txtPort.Text = Left(txtPort.Text, txtPort.SelStart - 1) & Right(txtPort.Text, Len(txtPort.Text) - txtPort.SelStart)
                txtPort.SelStart = Selidx - 1
            End If
    End If
End Sub
